const query = require("../db.js");
const { toSnakeCase } = require("./utils.js");

const deleteRecords = async (req, res) => {
  try {
    const client = req.params.client;
    const { tableName, data } = req.body;
    const dBtableName = `${client}_${toSnakeCase(tableName)}`;

    const tableCheck = await query(`
      SELECT EXISTS (SELECT 1 FROM pg_tables WHERE tablename = $1)
      AS table_exists`, [dBtableName]);
    if (!tableCheck.rows[0]["table_exists"]) {
      return res.status(404).json({ error: `Data collection ${tableName} not found.` });
    }

    const deleteQuery = `DELETE FROM ${dBtableName} WHERE id = $1`;

    for (item of data) {
      await query(deleteQuery, [item.id]);
    }

    res.status(200).json({ message: "Data removed successfully" });

  } catch (err) {
    console.error("Error handling the request:", err);
    res
      .status(500)
      .json({ error: "An error occurred while processing the request" });
  }
};

module.exports = deleteRecords;
